﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

using Microsoft.Phone.Tasks;        /*****************************/

namespace WindowsPhoneApplication1
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        private void btnMail_Click(object sender, RoutedEventArgs e)
        {
            EmailComposeTask emailTask = new EmailComposeTask();
            emailTask.Subject = "Dette er en test";
            emailTask.Body = "Jeg tester lige";
            emailTask.To = "bjbu@tietgen.dk";
            emailTask.Show();
        }

        private void btnBrowser_Click(object sender, RoutedEventArgs e)
        {
            WebBrowserTask browser = new WebBrowserTask();
            browser.URL = "http://webdemo.bjoerks.net/SimpleEksempler/doc3.htm";
            browser.Show();
        }

        private void btnHttpGet_Click(object sender, RoutedEventArgs e)
        {
            HttpWebRequest req = HttpWebRequest.Create(new Uri("http://webdemo.bjoerks.net/SimpleEksempler/doc3.htm", UriKind.RelativeOrAbsolute)) as HttpWebRequest;
            req.Method = "GET";
            req.BeginGetResponse(httpWebRequest_GetResponse_Callback, req);
        }

        private void httpWebRequest_GetResponse_Callback(IAsyncResult result)          // bruges både til GET og POST response
        {
            HttpWebRequest req = result.AsyncState as HttpWebRequest;
            WebResponse resp =  req.EndGetResponse(result);
            System.IO.Stream stream = resp.GetResponseStream();
            System.IO.StreamReader reader = new System.IO.StreamReader(stream);
            string text = reader.ReadToEnd();
            this.Dispatcher.BeginInvoke(() =>                                           // her bruges lamdaexpression til at sætte delegatmetode
            {
                /* Adgang til UI */
                textBlock1.Text = text;
                webBrowser1.NavigateToString(text);
            });
            reader.Close();
        }

        private void btnHttpGetMedUrlParameter_Click(object sender, RoutedEventArgs e)
        {
            HttpWebRequest req = HttpWebRequest.Create(new Uri("http://httptest.bjoerks.net/ResponsePostData.asp?urldata=hej", UriKind.RelativeOrAbsolute)) as HttpWebRequest;
            req.Method = "GET";
            req.BeginGetResponse(httpWebRequest_GetResponse_Callback, req);
        }

        private void btnHttpPost_Click(object sender, RoutedEventArgs e)
        {
            HttpWebRequest req = HttpWebRequest.Create(new Uri("http://httptest.bjoerks.net/ResponsePostData.asp", UriKind.RelativeOrAbsolute)) as HttpWebRequest;
            req.Method = "POST";
            req.ContentType = "Content-Type: application/x-www-form-urlencoded";
            req.BeginGetRequestStream(httpWebRequest_GetRequestStream_Callback, req);
        }

        private void httpWebRequest_GetRequestStream_Callback(IAsyncResult result)
        {
            HttpWebRequest req = result.AsyncState as HttpWebRequest;
            System.IO.Stream stream = req.EndGetRequestStream(result);
            System.IO.StreamWriter writer = new System.IO.StreamWriter(stream);

            writer.WriteLine("MinText=Indholdet&MitTal=129");
            writer.Flush();
            writer.Close();
            req.BeginGetResponse(httpWebRequest_GetResponse_Callback, req);
        }



        private void btnWebClient_Click(object sender, RoutedEventArgs e)
        {
            WebClient wclient = new WebClient();
            //wclient.OpenReadCompleted += WebClient_OpenReadCompleted;
            //wclient.OpenReadAsync(new Uri("http://httptest.bjoerks.net/test.htm"));       // man kan også få stream, hvis det passer bedre.
            wclient.DownloadStringCompleted += WebClient_DownloadStringCompleted;
            wclient.DownloadStringAsync(new Uri("http://httptest.bjoerks.net/test.htm"));
        }

        private void WebClient_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            if (!e.Cancelled && e.Error == null)
            {
                string text = e.Result;
                textBlock1.Text = text;
                webBrowser1.NavigateToString(text);
                //this.Dispatcher.BeginInvoke(() =>                                           // her bruges lamdaexpression til at sætte delegatmetode
                //{
                //    /* Adgang til UI */
                //    textBlock1.Text = text;
                //});

            }
        }

        private void WebClient_OpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            if (!e.Cancelled && e.Error == null)
            {
                System.IO.Stream stream = e.Result;
            }
        }

    }
}